<?php

//echo dirname(__FILE__);

include dirname(__FILE__)."/../cgi-bin/errataCorrigeSystem.php";
include dirname(__FILE__)."/../cgi-bin/errataCorrigeDatabase.php";
include dirname(__FILE__)."/../cgi-bin/errataCorrigeDataFunction.php";
include dirname(__FILE__)."/../cgi-bin/errataCorrigeMail.php";
include dirname(__FILE__)."/../cgi-bin/errataCorrigeUserFunction.php";
include "strutture.php";




$errataCorrigeSystem= new errataCorrigeSystem();
$errataCorrigeDatabase = new errataCorrigeDatabase();
$errataCorrigeDataFunction = new errataCorrigeDataFunction();
$errataCorrigeMailSystem = new errataCorrigeMail();
$codificatoreStrutture = new codificatoreStrutture();
$errataCorrigeUserFunction = new errataCorrigeUserFunction();
$errataCorrigeMail = new errataCorrigeMail();

$errataCorrigeSystem->startHeaders();

$ini_file_name = $errataCorrigeSystem->ritornaIniFileErrataGres();

$connTipo="main";




$link = $errataCorrigeDatabase->connetti($connTipo, $ini_file_name);


if (isset($_REQUEST['APPID'])) {
  $APPID = $_REQUEST['APPID'];
} else {
  $APPID = "";
};

if (isset($_REQUEST['LINGUA'])) {
  $LINGUA = $_REQUEST['LINGUA'];
} else {
  $LINGUA = "";
};






$query = "select * from mail_queue where \"STATO\"=0";


$mailRS = $errataCorrigeDatabase->query_rs($query,$link,$ini_file_name,$connTipo);


while ($mailToSend = $mailRS->FETCH()) {


  $TIPO_MESSAGGIO = $mailToSend["TIPO_MESSAGGIO"];
  $FROM = $mailToSend["FROM"];
  $TO = $mailToSend["TO"];
  $TIMESTAMP = $mailToSend["TIMESTAMP"];
  $STATO = $mailToSend["STATO"];
  $ID_CATALOGO = $mailToSend["ID_CATALOGO"];
  $ID_MAIL = $mailToSend["ID_MAIL"];
  $LINGUA = $mailToSend["LINGUA"];
  $PARAMETRI = $mailToSend["PARAMETRI"];
  $TENTATIVI = $mailToSend["TRY"];
  $TITOLO = "";

  switch($TIPO_MESSAGGIO) {

    case "NWU": //Nuovo utente

      $textToSend = mailNWU($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);

    break;
    case "CPW": //Cambio password
      $textToSend = mailCPW($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);

    break;
    case "CHR": //Chiarimento
      
      $textToSend = mailCHR($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);
      $parSplit = splitParametri($PARAMETRI);

      switch($LINGUA) {
        case "IT":
          $TITOLO="ErrataCorrige chiede un chiarimento sulla ".$parSplit[6];
        break;
        case "UK":
          $TITOLO="ErrataCorrige have a question for you about ".$parSplit[6];
        break;
        case "FR":
          $TITOLO="Traduzione";
        break;
        case "ES":
          $TITOLO="Traduzione";
        break;


      }
      

    break;
    case "NPA": //Nuovo progetto con allegato
      $textToSend = mailNPA($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);

      switch($LINGUA) {
        case "IT":
          $TITOLO="E' stato creato un progetto ErrataCorrige ...";
        break;
        case "UK":
          $TITOLO="A new ErrataCorrige project was created ...";
        break;
        case "FR":
          $TITOLO="Traduzione";
        break;
        case "ES":
          $TITOLO="Traduzione";
        break;


      }

      

    break;
    case "NPB": //Nuovo progetto senza allegato
      $textToSend = mailNPB($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);

      switch($LINGUA) {
        case "IT":
          $TITOLO="E' stato creato un progetto ErrataCorrige ...";
        break;
        case "UK":
          $TITOLO="A new ErrataCorrige project was created ...";
        break;
        case "FR":
          $TITOLO="Traduzione";
        break;
        case "ES":
          $TITOLO="Traduzione";
        break;


      }

    break;

    case "CPR": //Chiudi progetto
      $textToSend = mailCPR($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);

      switch($LINGUA) {
        case "IT":
          $TITOLO="E' stato chiuso un progetto ErrataCorrige ...";
        break;
        case "UK":
          $TITOLO="An ErrataCorrige project was closed ...";
        break;
        case "FR":
          $TITOLO="Traduzione";
        break;
        case "ES":
          $TITOLO="Traduzione";
        break;


      }


    break;

    case "INV": //Nuovo invito

    //  $textToSend = mailINV($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);
    $textToSend = mailINV($LINGUA,$PARAMETRI,$ini_file_name,$connTipo);

      switch($LINGUA) {
        case "IT":
          $TITOLO="Sei stato invitato su ErrataCorrige";
        break;
        case "UK":
          $TITOLO="You have been invited on ErrataCorrige";
        break;
        case "FR":
          $TITOLO="Traduzione";
        break;
        case "ES":
          $TITOLO="Traduzione";
        break;


      }
     break;

  }

  $mail = errataCorrige_mail($FROM,$TO,"","",$TITOLO,$textToSend,"",0);

      if ($mail) {
        //Chiudi il pending perchè è inviata
        chiudiMailPending($ID_MAIL,$ini_file_name,$connTipo,$link);
      }
      else
      {
        //Aggiungi 1 ai tentativi se arriva < 5 la chiude con stato 2 "errore"
        aggiungiTentativo($ID_MAIL,$TENTATIVI,$ini_file_name,$connTipo,$link);
      }

}


function mailNWU($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
    //Nuovo utente
}
function mailCPW($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
  //Cambio password
}
function mailCHR($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
  $errataCorrigeSystem= new errataCorrigeSystem();
  $urlRisorseErrata=$errataCorrigeSystem->errataApiUrl();
  $urlStorageErrata=$errataCorrigeSystem->errataStorageUrl();

  $mailReaded = "";
  //Parametri
  //Nome,Cognome,nomeProgetto,downloadRes
  $parametriSplit = splitParametri($PARAMETRI);
  array_push($parametriSplit,$urlRisorseErrata);
  array_push($parametriSplit,$urlStorageErrata);

  $mailReaded = file_get_contents("/var/www/thecorrige/errataCorrige/api3/mailTemplate/CHR_".$LINGUA.".html"); 
  $patterns = array(
    '/{nome}/',
      '/{cognome}/',
      '/{progetto}/',
      '/{res}/',
      '/{folder}/',
      '/{nota}/',
      '/{idrowec}/',
      '/{urlRisorseErrata}/',
      '/{urlStorageErrata}/'
    
      
);

$mailSprint = preg_replace($patterns, $parametriSplit, $mailReaded);

return $mailSprint;
  
}

function mailCPR($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
   
  $errataCorrigeSystem= new errataCorrigeSystem();
  $urlRisorseErrata=$errataCorrigeSystem->errataApiUrl();

$mailReaded = "";
  //Parametri
  //Nome,Cognome,nomeProgetto,downloadRes
  $parametriSplit = splitParametri($PARAMETRI);
  array_push($parametriSplit,$urlRisorseErrata);

  $mailReaded = file_get_contents("/var/www/thecorrige/errataCorrige/api3/mailTemplate/CPR_".$LINGUA.".html"); 
  $patterns = array(
    '/{nome}/',
    '/{cognome}/',
    '/{progetto}/'
);

$mailSprint = preg_replace($patterns, $parametriSplit, $mailReaded);

return $mailSprint;

}

function mailNPA($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
   
    $errataCorrigeSystem= new errataCorrigeSystem();
    $urlRisorseErrata=$errataCorrigeSystem->errataApiUrl();

  $mailReaded = "";
    //Parametri
    //Nome,Cognome,nomeProgetto,downloadRes
    $parametriSplit = splitParametri($PARAMETRI);
    array_push($parametriSplit,$urlRisorseErrata);

    $mailReaded = file_get_contents("/var/www/thecorrige/errataCorrige/api3/mailTemplate/NPA_".$LINGUA.".html"); 
    $patterns = array(
      '/{nome}/',
      '/{cognome}/',
      '/{progetto}/',
      '/{res}/',
      '/{folder}/'
  
  );
  
$mailSprint = preg_replace($patterns, $parametriSplit, $mailReaded);

return $mailSprint;

}
function mailNPB($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
  $errataCorrigeSystem= new errataCorrigeSystem();
    $urlRisorseErrata=$errataCorrigeSystem->errataApiUrl();

  $mailReaded = "";
    //Parametri
    //Nome,Cognome,nomeProgetto
    $parametriSplit = splitParametri($PARAMETRI);
    array_push($parametriSplit,$urlRisorseErrata);

    $mailReaded = file_get_contents("/var/www/thecorrige/errataCorrige/api3/mailTemplate/NPB_".$LINGUA.".html"); 
    $patterns = array(
      '/{nome}/',
      '/{cognome}/',
      '/{progetto}/'
      
  
  );
  
$mailSprint = preg_replace($patterns, $parametriSplit, $mailReaded);

return $mailSprint;
}


function mailINV($LINGUA,$PARAMETRI,$ini_file_name,$connTipo) {
  $errataCorrigeSystem= new errataCorrigeSystem();
  $urlRisorseErrata=$errataCorrigeSystem->errataApiUrl();

$mailReaded = "";
  //Parametri
  //chi invita,invitato,catalogo,numero invito
  $parametriSplit = splitParametri($PARAMETRI);
  array_push($parametriSplit,$urlRisorseErrata);

  $mailReaded = file_get_contents("/var/www/thecorrige/errataCorrige/api3/mailTemplate/NPB_".$LINGUA.".html"); 
  $patterns = array(
    '/{nome}/',
    '/{cognome}/',
    '/{progetto}/'
    

);

$mailSprint = preg_replace($patterns, $parametriSplit, $mailReaded);

return $mailSprint;
}

function splitParametri($PARAMETRI) {
  $parametriSplit = explode("|",$PARAMETRI);
  
  return $parametriSplit;
}

function chiudiMailPending($ID_MAIL,$ini_file_name,$connTipo,$link) {
  $errataCorrigeDatabase = new errataCorrigeDatabase();
  $query = "update mail_queue set \"STATO\"=1 where \"ID_MAIL\"= $ID_MAIL";
  

  $exe = $errataCorrigeDatabase->query_exe($query,$ini_file_name,$connTipo,$link);
}

function aggiungiTentativo($ID_MAIL,$TENTATIVI,$ini_file_name,$connTipo,$link) {
  $errataCorrigeDatabase = new errataCorrigeDatabase();

  if ($TENTATIVI < 5) {
    $TENTATIVI = $TENTATIVI++;
    $query = "update mail_queue set \"TRY\" = $TENTATIVI";

    $exe = $errataCorrigeDatabase->query_exe($query,$ini_file_name,$connTipo,$link);
  }
  else
  {
    $query = "update mail_queue set \"STATO\"=2 where \"ID_MAIL\"= $ID_MAIL";

    $exe = $errataCorrigeDatabase->query_exe($query,$ini_file_name,$connTipo,$link);
  }

}

function errataCorrige_mail($from,$to,$nome,$cognome,$oggetto,$testo,$endurl,$mailDebugLevel)
{
   // error_handling(1);
    require_once '/var/www/thecorrige/errataCorrige/cgi-bin/PHPMailer-master/PHPMailerAutoload.php';



    
                        $mail = new PHPMailer (true);
         try {
    
                         $mail->SMTPDebug = $mailDebugLevel;                                       // Enable verbose debug output
                          $mail->isSMTP();                                      // Set mailer to use SMTP
                          $mail->Host = 'mail.erratacorrige.us';                     // Specify main and backup server
                          $mail->SMTPAuth = true;                               // Enable SMTP authentication
                          $mail->Username = 'system@erratacorrige.us';                            // SMTP username
                          $mail->Password = 'S@;LBpMp8wzC';                           // SMTP password
                         $mail->SMTPSecure = 'ssl';                            // Enable encryption, 'ssl' also accepted
                          $mail->Port       = 465;                                     // TCP port to connect to

                        $mail->From = $from;
                        $mail->FromName = $from;
                        $mail->addAddress($to, '');  // Add a recipient

                        //$mail->WordWrap = 50;                                 // Set word wrap to 50 characters
                        //$mail->addAttachment('/var/tmp/file.tar.gz');         // Add attachments
                        //$mail->addAttachment('/tmp/image.jpg', 'new.jpg');    // Optional name
                        $mail->isHTML(true);                                  // Set email format to HTML

                        $mail->Subject = $oggetto;
                        $mail_body    = $testo;

                        $mail->Body = $mail_body;
                    //    $mail->AltBody = 'This is the body in plain text for non-HTML mail clients';

                        if(!$mail->send()) {
                           echo 'Il messaggio non pu&ograve; essere inviato.';
                           echo ' Error: ' . $mail->ErrorInfo;
                           return $mail->ErrorInfo;
                        }
                        else
                        {
                           return true;
                           
                        }

             } catch (phpmailerException $e) {
              echo $e->errorMessage(); //Pretty error messages from PHPMailer
            } catch (Exception $e) {
              echo $e->getMessage(); //Boring error messages from anything else!
            }
}
